SystemOrganization addCategory: #'GBT-DSL_EFA'!

Object subclass: #Auswertungen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Auswertungen class methodsFor: 'contexts' stamp: 'hk 7/30/2016 17:12'!
auswertungenContext
	"comment stating purpose of message"
	
	^GbtPlainAC newStruct: 'Auswertungen' define: {
		{#displayAs: . 'Auswertungen'} .
		{#uiSpec:icon: . #GbtListAndItemUI . #beitragsMgmt16} .
		{#templates: . self fahrtContext} .
		{#loadPolicy: . #autoload } .
		{#display: . #( #(bootsName Boot) #(steuermann Steuermann) #(abfahrt Abfahrt))} .
		{#subcontext: . self fahrtContext}
		}
! !

Object subclass: #EFA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!EFA class methodsFor: 'contexts' stamp: 'CC 7/21/2016 19:32'!
efa
	"self efa" 
	^GbtMainAC newStruct: 'EFAContext' define: {
		{#aspect:on: . Fahrtenbuch fahrtenBuchContext . nil  } .
"		{#aspect:on: . Auswertungen auswertungenContext . nil  } ."
		{#aspect:on: . Boote booteContext. nil  } .
		{#aspect:on: . Personen personenContext . nil } .
		{#aspect:on: . Beitragsmanagement beitragsmanagementContext . nil } .	
"		{#aspect:on: . BeitragsStammdaten beitragsStammdatenContext . nil } ."
		{#aspect:on: . Statistics statisticsContext . nil } .
		{#uiSpec:icon: . #GbtMainUI . #main} }! !

!EFA class methodsFor: 'example' stamp: 'hk 8/18/2016 16:45'!
exampleData
	self storeTestFahrten.
	self storeTestPersonen.
	self storeTestBoote.
	self storeTestBeitragstabellen.
"	self storeBeitragsmanagement.
	self storeBeitragsabrechnungen.
"	! !

!EFA class methodsFor: 'example' stamp: 'hk 7/12/2016 18:41'!
exampleRun
	"initializ, build main efy context, add policies for various core data, open ui"

	| ui ctx |
	GbtSVO initializeAll.
	ctx := self efa.
	ctx addPolicy: #FahrtNoPolicy prefix: 'Fahrt'.
	ctx addPolicy: #SportlerNoPolicy prefix: 'Sportler'.
	ctx addPolicy: #MitgliedNoPolicy prefix: 'Mitglied'.
	ctx addPolicy: #BootNoPolicy prefix: 'Boot'.
	ctx addPolicy: #BeitragsTabelleNoPolicy prefix: 'BeitragsTabelle'.
	ctx addPolicy: #BeitragsAbrechnungsNoPolicy prefix: 'Abrechnung_'.
	ctx addPolicy: #RechnungNoPolicy prefix: 'Rng'.
	ctx addPolicy: #StatistikNoPolicy prefix: 'Stat_'.
	ctx addPolicy: #MahnungNoPolicy prefix: 'Mahnung'.
	(ui:= ctx ui) title: ('EFA        ', ui title); open. 
! !

!EFA class methodsFor: 'test data' stamp: 'CC 8/12/2016 18:53'!
storeBeitragsmanagement
	Beitragsmanagement beitragsmanagement01
! !

!EFA class methodsFor: 'test data' stamp: 'CC 8/7/2016 18:52'!
storeTestBeitragstabellen
	Beitragstabellen beitragstabellenliste1! !

!EFA class methodsFor: 'test data' stamp: 'CC 8/7/2016 18:07'!
storeTestBoote
	Boote booteListe1! !

!EFA class methodsFor: 'example' stamp: 'hk 8/11/2016 12:58'!
storeTestFahrten
	Fahrtenbuch  storeTestFahrten! !

!EFA class methodsFor: 'test data' stamp: 'CC 8/7/2016 17:45'!
storeTestPersonen
	Personen personenListe1
! !

Object subclass: #Fahrtenbuch
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Fahrtenbuch class methodsFor: 'things' stamp: 'hk 8/21/2016 19:09'!
besatzung
	"self besatzung edit"
	^GbtThing newStruct: 'Besatzung' define: {
		{ #summary . 'system template'}.
		{ #Steuermann . #thing: .  self ruderer}.
		{ #Mannschaft . #listOf: .  self ruderer}.
	}! !

!Fahrtenbuch class methodsFor: 'examples' stamp: 'CC 6/26/2016 20:58'!
exampleRun
	GbtSVO initializeAll.
	self fahrtenBuchContext ui title: #Fahrtenbuch; open! !

!Fahrtenbuch class methodsFor: 'things' stamp: 'hk 8/19/2016 11:54'!
fahrt
	"self fahrt edit"
	^GbtThing newStruct: 'Fahrt' define: {
	 	{ #summary . '#bizId : #Steuermann:RudererName #Mannschaft ab: #Abfahrt an: #Ankunft' }.
		{ #idNumberPolicy . #FahrtNoPolicy }.
		{ #Datum . #date: . Date today}.
		{ #Boot . #thing: .  Boote boot}.
		{ #Besatzung . #thing: .  self besatzung}.
		{ #Abfahrt . #date: . '1 July 2016' }.
		{ #Ankunft . #date: . '2 July 2016' }.
		{ #Ziel . #enum: .  #(Fluss Mündung)}.
		{ #Kilometer . #no: .  0}.
	} full: { 
		{ #Bemerkung . #text: . ''}.	
		{ #FahrtArt . #enum: . #(NormaleFahrt Trainingsfahrt Wanderfahrt)}.			
	}! !

!Fahrtenbuch class methodsFor: 'contexts' stamp: 'CC 7/21/2016 19:32'!
fahrtContext
	"comment stating purpose of message"
	
	^GbtPlainAC newStruct: 'FahrtContext' define: {
		{#displayAs: . 'Fahrt'  } .
		{#uiSpec:icon: . # GbtDiItemUI . #rowingTeam}.
		{#chooseFor:with: . #Boot . Boote booteContext }.
		{#chooseFor:with:from: . #Steuermann . self rudererDeclarative . Personen personenContext }.
		{#chooseFor:with:from: . #Mannschaft . self rudererDeclarative . Personen personenContext }.
		}
! !

!Fahrtenbuch class methodsFor: 'contexts' stamp: 'CC 8/7/2016 18:02'!
fahrtenBuchContext
	"comment stating purpose of message"
	
	^GbtBigListAC newStruct: 'FahrtenBuchContext' define: {
		{#displayAs: . 'FahrtenBuch'} .
		{#uiSpec:icon: . #GbtListAndItemUI . #rowingTeam} .
		{#templates: . self fahrt} .
		{#loadPolicy: . #autoload } .
		{#display: . #( #(Bootsname Boot) #(RudererName Steuermann) Abfahrt)} .
		{#subcontext: . self fahrtContext}
		}
! !

!Fahrtenbuch class methodsFor: 'things' stamp: 'hk 8/11/2016 12:51'!
ruderer
	"self ruderer edit"
	
	^GbtThing newStruct: 'Ruderer' define: {
		{ #summary . '#RudererName , #RudererVorname' }.
		{ #purposes . #(Steuermann Ruderer) }.
		{ #RudererName . #val: . ''}.
		{ #RudererVorname . #val: .  ''}.
		{ #SportlerId . #val: .  ''}.
	} full: { 
		{ #FremdVerein. #val: . ''}.					
	}! !

!Fahrtenbuch class methodsFor: 'declaratives' stamp: 'CC 7/22/2016 15:15'!
rudererDeclarative
	^GbtDeclarative newStruct: 'RudererDeclarative' define: { 
		{ #RudererName . #tag: . #Nachname }.
		{ #RudererVorname . #tag: . #Vorname }.
		{ #SportlerId . #tag: .  #bizId}.
		{ #FremdVerein }.					
	} ! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 8/11/2016 12:55'!
storeTestFahrten
	self testFahrt1 save.	
	self testFahrt2 save.
	self testFahrt3 save.
	self testFahrt4 save.	
	self testFahrt5 save.
	self testFahrt6 save.! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 8/11/2016 12:56'!
testFahrt1
	^self testFahrt1: Fahrtenbuch fahrt! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 8/11/2016 12:56'!
testFahrt1: aFahrt
	^aFahrt 
		Bootsname: #Alster;
		Steuermann: self testRuderer1;
		Kilometer: 20;
		yourself
! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 8/11/2016 12:56'!
testFahrt2
	^self testFahrt2: Fahrtenbuch fahrt! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 8/11/2016 12:56'!
testFahrt2: aFahrt
	^aFahrt 
		Bootsname: #Alster;
		Steuermann: self testRuderer2;
		Kilometer: 28;
		yourself
! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 8/11/2016 12:56'!
testFahrt3
	^self testFahrt3: Fahrtenbuch fahrt! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 8/11/2016 12:56'!
testFahrt3: aFahrt
	^aFahrt 
		Bootsname: #Alster;
		Steuermann: self testRuderer3;
		Kilometer: 30;
		yourself
! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 8/11/2016 12:56'!
testFahrt4
	^self testFahrt4: Fahrtenbuch fahrt! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 8/11/2016 12:56'!
testFahrt4: aFahrt
	aFahrt Mannschaft newEntry: self testRuderer1 .
	^aFahrt 
		Bootsname: #Elbe;
		Steuermann: self testRuderer3;
		Kilometer: 99;
		yourself
! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 8/11/2016 12:56'!
testFahrt5
	^self testFahrt5: Fahrtenbuch fahrt! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 8/11/2016 12:56'!
testFahrt5: aFahrt
	aFahrt Mannschaft newEntry: self testRuderer2.
	^aFahrt 
		Bootsname: #Elbe;
		Steuermann: self testRuderer3;
		Kilometer: 77;
		yourself
! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 8/11/2016 12:56'!
testFahrt6
	^self testFahrt6: Fahrtenbuch fahrt! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 8/11/2016 12:56'!
testFahrt6: aFahrt
	aFahrt Mannschaft newEntry: self testRuderer3.
	^aFahrt 
		Bootsname: #Elbe;
		Steuermann: self testRuderer3;
		Kilometer: 66;
		yourself
! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 8/11/2016 12:56'!
testRuderer1
	^self testRuderer1: Fahrtenbuch ruderer! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 8/11/2016 12:56'!
testRuderer1: aRuderer
	^aRuderer
		RudererName: #Schmidt1;
		RudererVorname: #Henning;
		yourself! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 8/11/2016 12:56'!
testRuderer2
	^self testRuderer2: Fahrtenbuch ruderer! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 8/11/2016 12:56'!
testRuderer2: aRuderer
	^aRuderer
		RudererName: #Schmidt2;
		RudererVorname: #Henning;
		yourself! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 8/11/2016 12:56'!
testRuderer3
	^self testRuderer3: Fahrtenbuch ruderer! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 8/11/2016 12:56'!
testRuderer3: aRuderer
	^aRuderer
		RudererName: #Schmidt3;
		RudererVorname: #Henning;
		yourself! !

Object subclass: #Finanzen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

Finanzen subclass: #Beitragsabrechnung
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Beitragsabrechnung class methodsFor: 'things' stamp: 'hk 8/21/2016 19:15'!
abrechnungszeitraum
	"self abrechnungszeitraum edit"
	
	^GbtThing newStruct: 'Abrechnungszeitraum' define: {
		{ #summary . 'system template' }.
		{ #Von . #date: . Date current}.
		{ #bis . #date: . Date current}.	
	} full: { 
	}! !

!Beitragsabrechnung class methodsFor: 'things' stamp: 'hk 8/18/2016 17:22'!
beitrag
	"self beitrag edit"
	
	^GbtThing newStruct: 'Beitrag' define: {
		{ #summary .  '#Nachname #Vorname EUR #Betrag'}.	
		{ #Berechnungsdatum . #date: . Date current}.
		{ #Nachname . #val: . ''}.
		{ #Vorname . #val: . ''}.
		{ #Mitgliedsnummer . #val: . ''}.
		{ #FamilienOberhaupt . #enum: . #(false true) }.	
		{ #Mitgliedstatus . #enum: .  #(aktiv passiv) }.	
		{ #Beitragstatus . #enum: . #(Erwachsener 'Nichtverdiener14plus' 'Kind14minus')}.	
		{ #Familienname . #val: . ''}.
		{ #FamilienmitgliedNr . #no: . 1}.
		{ #normalBeitrag . #no: . 0}.
		{ #Familienrabatt . #no: . 0}.
		{ #Mindestbeitrag . #no: . 0}.
		{ #ermBeitrag . #no: . 0}.
		{ #beitrag . #no: . 0}.
		{ #Betrag . #no: . 0}.
		{ #Währung . #val: . 'EUR'}.
		{ #vz . #val: . '' }.
		{ #rz . #val: . ''}.
		{ #az . #no: . 1 }.
		{ #Rechnungserzeugung . #enum: . #(false true)}.
		{ #Fälligkeit . #date: . Date current}.	
	}! !

!Beitragsabrechnung class methodsFor: 'contexts' stamp: 'CC 8/12/2016 21:18'!
beitragContext
	"self beitragContext edit"

	^GbtPlainAC newStruct: 'BeitragContext' define: {
		{#displayAs: . 'Beitrag'  } .
		{#uiSpec:icon: . # GbtItemUI . #beitragsMgmt16}
		}
! !

!Beitragsabrechnung class methodsFor: 'declaratives' stamp: 'hk 8/25/2016 17:15'!
beitragDecl
	"Input Person & Beitragstabelle mit beitragXLS"

	^GbtDeclarative newStruct: 'Beitrag' define: { 
		{ #Berechnungsdatum }.
	"von Person"
		{ #Nachname }.
		{ #Vorname }.
		{ #Mitgliedsnummer . #tag: . #bizId }.
		{ #FamilienOberhaupt }.	
		{ #Mitgliedstatus }.	
		{ #Beitragstatus }.	
		{ #Familienname }.
		{ #FamilienNummer }.
		{ #FamilienmitgliedNr }.	
	"von Beitragstabelle"
		{ #aktiv}.
		{ #passiv}.
		{ #Familienrabatt }.
		{ #Mindestbeitrag }.
		{ #normalBeitrag }.
		{ #ermBeitrag }.
		{ #beitrag }.
		{ #Betrag }.
		{ #Währung }.
		{ #vz . #tag: . #vollzahler }.
		{ #rz . #tag: . #rabattiert }.
		{ #az . #tag: . #anzahl }.
	"misc"
		{ #Rechnungserzeugung }.
		{ #Fälligkeit }
		}! !

!Beitragsabrechnung class methodsFor: 'things' stamp: 'hk 8/19/2016 12:03'!
beitragsabrechnung
	"self beitragsabrechnung edit"
	
	^GbtThing newStruct: 'Beitragsabrechnung' define: {
		{ #summary .  '#Abrechnungsname #BeitragssummeGesamt'}.
		{ #idNumberPolicy . #BeitragsAbrechnungsNoPolicy }.
		{ #Abrechnungsgenauigkeit . #enum: . #(Tag Monat Halbjahr Jahr)}. "für unterjährigen Eintritt/Austritt"
		{ #Abrechnungsname . #val: . ''}.
		{ #Abrechnungszeitraum . #thing: . self abrechnungszeitraum}.
		{ #Beitragstabelle . #thing: . Beitragstabellen beitragstabelle}.
		{ #Abrechner . #val: . ''}.
		{ #Beitragsliste . #listOf: . self beitrag}.
		{ #BeitragssummeGesamt . #sum: . #beitrag}.
		{ #AnzahlVollzahler . #sum: . #vz }.
		{ #AnzahlRabattierteMitglieder . #sum: . #rz }.
		{ #AnzahlMitglieder . #sum: . #az }.
	}! !

!Beitragsabrechnung class methodsFor: 'contexts' stamp: 'hk 8/30/2016 11:06'!
beitragsabrechnungContext

	self beitragDecl.	"stellt das Declarative HKBeitrag bereit"

	^GbtPlainAC newStruct: 'BeitragsabrechnungContext' define: {
		{#displayAs: . 'Beitragsabrechnung'} .
		{#uiSpec:icon: . #GbtItemWithTabsUI . #beitragsMgmt16} .
		{#aspect:on: . self beitragslisteContext . #Beitragsliste } .
		{#menu:items: . #BeitraegsMenu . #('Beitragsabrechnungen erstellen' 'Einbuchen') }.
		{#behavior:actions: . #'Beitragsabrechnungen erstellen' . 
			#(MAPBL PersonenContext 
			 ASSIGNSLOT #(Beitragstabelle vBTab)  
			 ALTER #( vBTab Beitrag ) 
			 FREEZE void  
			 REDUCE #(contextVO Beitragsliste) )}
	}! !

!Beitragsabrechnung class methodsFor: 'contexts' stamp: 'hk 8/18/2016 17:24'!
beitragsabrechnungenContext
	"comment stating purpose of message"
	
	^GbtBigListAC newStruct: 'BeitragsabrechungenContext' define: {
		{#displayAs: . 'Beitragsabrechnungen'} .
		{#uiSpec:icon: . #GbtListAndItemUI . #beitragsMgmt16} .
		{#templates: . self beitragsabrechnung} .
		{#loadPolicy: . #autoload }.
		{#chooseFor: . #Beitragstabelle }.
		{#chooseWith: . Beitragstabellen beitragstabellenContext }.
		{#display: . #( #(BeitragssummeGesamt Summe) #(AnzahlMitglieder Mitglieder) #(AnzahlVollzahler Vollzahler) #(AnzahlRabattierteMitglieder #rabattiert) )}.
		{#subcontext: . self beitragsabrechnungContext}
		}
! !

!Beitragsabrechnung class methodsFor: 'contexts' stamp: 'hk 8/18/2016 16:36'!
beitragslisteContext
	"comment stating purpose of message"
	
	^GbtUlistAC newStruct: 'BeitragslisteContext' define: {
		{#displayAs: . 'Beitragsliste'  } .
		{#uiSpec:icon: . # GbtListAndItemUI . #beitragsMgmt16}.
		{#template:for: . self beitrag . #Beitragsliste} .
		{#display: . #(Nachname Vorname Betrag)} .
		{#subcontext: . self beitragContext}
		}! !

Finanzen subclass: #Beitragsmanagement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Beitragsmanagement class methodsFor: 'things' stamp: 'hk 8/18/2016 16:35'!
beitragsmanagement
	"self beitragsmanagement edit"
	
	^GbtThing newStruct: 'Beitragsmanagment' define: {
		{ #AktuellerAbrechnungszeitraum . #val: . ''}.
		{ #OffeneBeiträge . #no: . 0}.
		{ #Beitragstabellen . #thing: . Beitragstabellen beitragstabelle }.
		{ #Beitragsabrechnungen . #thing: . Beitragsabrechnung beitragsabrechnung}.
		{ #Rechnungen . #thing: . Rechnungen rechnung}.
"		{ #opListen . #thing: . self opListen}."
	} full: { 
	}! !

!Beitragsmanagement class methodsFor: 'test data' stamp: 'CC 8/12/2016 18:51'!
beitragsmanagement01
	"self beitragsmanagement01 edit"
	^(self beitragsmanagement01: self beitragsmanagement) save
! !

!Beitragsmanagement class methodsFor: 'test data' stamp: 'CC 8/12/2016 18:50'!
beitragsmanagement01: b
	"self beitragsmanagement01 edit"
	
	b Beitragstabellen: Beitragstabellen beitragsTabelle2016.
	^b! !

!Beitragsmanagement class methodsFor: 'contexts' stamp: 'CC 8/7/2016 18:19'!
beitragsmanagementContext
	"comment stating purpose of message"
	
	^GbtPlainAC newStruct: 'BeitragsmanagementContext' define: {
		{#displayAs: . 'Beitragsmanagment'} .
		{#uiSpec:icon: . #GbtItemWithTabsUI . #beitragsMgmt16} .
		{#vo: . self beitragsmanagement} .
		{#loadPolicy: . #autoload } .
		{#aspect:on: . Beitragstabellen beitragstabellenContext . #Beitragstabellen } .
		{#aspect:on: . Beitragsabrechnung beitragsabrechnungenContext . #Beitragsabrechnungen } .
		{#aspect:on: . Rechnungen rechnungenContext . #Rechnungen } .
"		{#aspect:on: . OPListen opListenContext . #opListen } "
		{#menu:items: . #Beitragsmanagement . #(#'Do Something 1' #'Do Something 2') }.
		}
! !

!Beitragsmanagement class methodsFor: 'examples' stamp: 'CC 7/12/2016 11:58'!
exampleRun
	| ui |
	GbtSVO initializeAll.
	(ui := self beitragsmanagementContext ui) title: ('Beitragsmanagement', ui title); open! !

Finanzen subclass: #Beitragstabellen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Beitragstabellen class methodsFor: 'things' stamp: 'hk 8/21/2016 19:10'!
basisBeitragAktiv
	"self HKbasisBeitragAktiv edit"
	
	^GbtThing newStruct: 'BasisBeitragAktiv' define: {
		{ #summary . 'system template' }.
		{ #Erwachsener . #no: . 230 }.
		{ #Nichtverdiener14plus . #no: . 135}.
		{ #Kind14minus . #no: . 100}.
	}! !

!Beitragstabellen class methodsFor: 'things' stamp: 'hk 8/21/2016 19:10'!
basisBeitragPassiv
	"self BasisBeitragPassiv edit"
	
	^GbtThing newStruct: 'BasisBeitragPassiv' define: {
		{ #summary . 'system template' }.
		{ #Erwachsener . #no: . 115 }.
		{ #Nichtverdiener14plus . #no: . 115}.
		{ #Kind14minus . #no: . 115}.
	}! !

!Beitragstabellen class methodsFor: 'things' stamp: 'hk 8/25/2016 18:24'!
beitragXLS
	"self HKbasisBeitrag editD"
	
	^GbtThing newStruct: 'BeitragXLS' define: {
		{ #summary . 'system template'}.
		{ #aktiv . #thing:tag: . self basisBeitragAktiv . #aktiv}.
		{ #passiv . #thing:tag: . self basisBeitragPassiv . #passiv}.
		{ #Währung . #val: . #EUR }.
		{ #Mindestbeitrag . #no: . 70.00 }.		
		{ #Familienrabatt . #no: . 0.5}.		
		{ #normalBeitrag . #lookup: . '#Mitgliedstatus #Beitragstatus' }.	
		{ #ermBeitrag . #calc: . '( #FamilienmitgliedNr asNumber = 2) ifTrue: [ #normalBeitrag asNumber* #Familienrabatt asNumber ] ifFalse: [ #Mindestbeitrag ] '}.
		{ #beitrag . #calc: . '( #FamilienOberhaupt = ''true'') ifTrue:[ #normalBeitrag ] ifFalse:[ #ermBeitrag ]' }.
		{ #Betrag . #calc: . ' #beitrag asNumber max: ( #Mindestbeitrag asNumber)' }.
		{ #vollzahler . #calc: . '( #Betrag = #normalBeitrag ) ifTrue:[1]ifFalse:[0]' }.
		{ #rabattiert . #calc: . '( #Betrag = #normalBeitrag ) ifTrue:[0]ifFalse:[1]' }.
		{ #anzahl . #no: . 1 }
	}! !

!Beitragstabellen class methodsFor: 'test data' stamp: 'hk 8/18/2016 16:23'!
beitragsTabelle2016
	^self beitragsTabelle2016: self beitragstabelle! !

!Beitragstabellen class methodsFor: 'test data' stamp: 'hk 8/19/2016 12:05'!
beitragsTabelle2016: t
	"self beitragsTabelle2016 editD"
	
	^t TabellenName: #Tabelle2016 ;
		GültigkeitVon: '01.01.2016' ;
		GültigkeitBis: '12.31.2016';
		Mindestbeitrag: 70.00 ;		
		Familienrabatt: 0.5;		
		BeschlossenAm: '03.02.2016';	
		Abrechnungsmodus: #GanzjahresAbrechnung	;
		yourself
! !

!Beitragstabellen class methodsFor: 'test data' stamp: 'hk 8/18/2016 16:28'!
beitragsTabelle2016HJ1
	^self beitragsTabelle2016HJ1: self beitragstabelle! !

!Beitragstabellen class methodsFor: 'test data' stamp: 'hk 8/19/2016 11:59'!
beitragsTabelle2016HJ1: t
	"self beitragsTabelle2016HJ1 editD"
	
	^t TabellenName: #Tabelle2016 ;
		GültigkeitVon: '01.01.2016' ;
		GültigkeitBis: '06.30.2016';
		Mindestbeitrag: 70.00 ;		
		Familienrabatt: 0.5;		
		BeschlossenAm: '03.02.2016';		
		yourself
! !

!Beitragstabellen class methodsFor: 'test data' stamp: 'hk 8/18/2016 16:28'!
beitragsTabelle2016HJ2
	^self beitragsTabelle2016HJ2: self beitragstabelle! !

!Beitragstabellen class methodsFor: 'test data' stamp: 'hk 8/19/2016 11:59'!
beitragsTabelle2016HJ2: t
	"self beitragsTabelle2016HJ1 editD"
	
	^t TabellenName: #Tabelle2016 ;
		GültigkeitVon: '07.01.2016' ;
		GültigkeitBis: '12.31.2016';
		Mindestbeitrag: 80.00 ;		
		Familienrabatt: 0.4;		
		BeschlossenAm: '03.02.2016';		
		yourself
! !

!Beitragstabellen class methodsFor: 'things' stamp: 'hk 8/25/2016 17:21'!
beitragstabelle
	"self HKbeitragstabelle editD"
	
	^GbtThing newStruct: 'HKBeitragstabelle' define: {
		{ #summary . 'system template' }.
		{ #summary .  '#TabellenName : #GültigkeitVon - #GültigkeitBis '}.	
		{ #idNumberPolicy . #BeitragsTabelleNoPolicy }.
		{ #TabellenName . #val: . ''}.
		{ #GültigkeitVon . #date: . Date current}.
		{ #GültigkeitBis . #date: . Date current}.
		{ #Abrechnungsmodus . #enum: . #(HalbjahresAbrechnung GanzjahresAbrechnung) }.
		{ #BeitragXLS . #thing: . self beitragXLS }.
		{ #BeschlossenAm . #date: . Date current}.		
		{ #BeschlossenDurch . #enum: . #(Hauptversammlung Sonderregelung)}.	
	}! !

!Beitragstabellen class methodsFor: 'contexts' stamp: 'CC 7/21/2016 19:10'!
beitragstabelleContext
	""
	^GbtPlainAC newStruct: 'BeitragstabelleContext' define: {
		{#displayAs: . 'Beitragstabelle'} .
		{#uiSpec:icon: . #GbtDiItemUI . #beitragsMgmt16} .
		}
! !

!Beitragstabellen class methodsFor: 'contexts' stamp: 'hk 8/18/2016 16:26'!
beitragstabellenContext
	""
	^GbtBigListAC newStruct: 'BeitragstabellenContext' define: {
		{#displayAs: . 'Beitragstabellen'} .
		{#uiSpec:icon: . #GbtListAndItemUI . #bizoffer16} .
		{#templates: . self beitragstabelle} .
		{#loadPolicy: . #autoload } .
		{#display: . #( #(TabellenName Name) #(GültigkeitVon gültigVon) #(GültigkeitBis gültigBis))} .
		{#subcontext: . self beitragstabelleContext}
		}
! !

!Beitragstabellen class methodsFor: 'test data' stamp: 'hk 8/18/2016 16:30'!
beitragstabellenliste1
	self beitragsTabelle2016 save.
	self beitragsTabelle2016HJ1 save.
	self beitragsTabelle2016HJ2 save.! !

!Beitragstabellen class methodsFor: 'contexts' stamp: 'CC 7/21/2016 19:10'!
exampleRun
	| ui |
	GbtSVO initializeAll.
	(ui := self beitragstabellenContext ui) title: ('Beitragstabellen', ui title); open! !

Finanzen subclass: #OPListen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!OPListen class methodsFor: 'things' stamp: 'CC 8/22/2016 19:33'!
opListe
	"self OPListe edit"
	
	^GbtThing newStruct: 'opListe' define: {
		{ #summary .  '#bizId #Berechnungsdatum EUR #Beitragshöhe'}.	
		{ #idNumberPolicy  . #OPListeNoPolicy}.
		{ #Bezeichnung. #val: . ''}.
		{ #Erstellung . #enum: . #(Rechnung Storno)}.
		{ #OPListeAktuell . #listOf: . Rechnungen rechnung}.
		{ #OPSumme . #no: . 0}.
	} full: { 
	}! !

!OPListen class methodsFor: 'contexts' stamp: 'CC 8/22/2016 19:33'!
opListeContext
	""
	^GbtPlainAC newStruct: 'opListeContext' define: {
		{#displayAs: . 'OPListe'} .
		{#uiSpec:icon: . #GbtDiItemUI . #beitragsMgmt16} .
		{#behavior:actions: . #'Mahnungen verschicken' . 
			#(HALT void )}
		}
! !

!OPListen class methodsFor: 'contexts' stamp: 'CC 8/22/2016 19:34'!
opListenContext
	""
	^GbtBigListAC newStruct: 'opListenContext' define: {
		{#displayAs: . 'OPListen'} .
		{#uiSpec:icon: . #GbtListAndItemUI . #bizoffer16} .
		{#templates: . self opListe} .
		{#loadPolicy: . #autoload } .
		{#display: . #( #(bizId Rechnungsnummer) #(Rechnungsbeitrag Beitrag) )} .
		{#subcontext: . self opListeContext}
		}
! !

Finanzen subclass: #Rechnungen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Rechnungen class methodsFor: 'examples' stamp: 'CC 7/12/2016 12:24'!
exampleRun
	| ui |
	GbtSVO initializeAll.
	(ui := self rechnungenContext ui) title: ('Beitragsrechnungen', ui title); open! !

!Rechnungen class methodsFor: 'things' stamp: 'hk 8/25/2016 16:56'!
familienConstraint
	"self familienConstraint editD"
	^GbtThing newStruct: 'FamilienConstraint' define: { 
		{ #mitglied . #constraint: . '#FamilienmitgliedNr asNumber >1'}.
		{ #familie  . #constraint: . '#FamilienNummer = #AdressatNummer'} }! !

!Rechnungen class methodsFor: 'things' stamp: 'hk 8/25/2016 16:52'!
oberhauptConstraint
	"self oberhauptConstraint editD"
	^GbtThing newStruct: 'OberhauptConstraint' define: { 
		{ #mitglied . #constraint: . '#FamilienmitgliedNr asNumber = 1'} }! !

!Rechnungen class methodsFor: 'things' stamp: 'hk 8/25/2016 15:29'!
rechnung
	"self rechnung edit"
	
	^GbtThing newStruct: 'Rechnung' define: {
		{ #summary .  '#bizId #Berechnungsdatum EUR #Beitragshöhe'}.	
		{ #idNumberPolicy  . #RechnungNoPolicy}.
		{ #Rechnungstyp . #enum: . #(Rechnung Storno)}.
		{ #Rechnungsdatum . #date: . Date current}.
		{ #Rechnungskopf . #val: . 'Absender aus Vereinsstammdaten'}.
		{ #Rechnungsadresse . #thing: . self rechnungsadresse}.
		"Decl(Beitrag) mit Name, Vorname und anderen Daten"
		{ #Rechnungspositionen . #listOf: . self rechnungsposition}.	
		{ #Rechnungsbeitrag . #sum: . #Betrag}.	
	} full: { 
		{ #Eingebucht . #enum: . #(false true)}.
		{ #Buchungsdatum . #date: . Date current}.
		{ #Fälligkeit . #date: . Date current}.
	}
! !

!Rechnungen class methodsFor: 'declaratives' stamp: 'hk 8/25/2016 17:13'!
rechnungBeitragDeclarative
	^GbtDeclarative newStruct: 'RechnungBeitragDecl' define: { 
		"aus Beitrag"
		{ #Berechnungsdatum }.
		{ #Nachname }.
		{ #Vorname }.
		{ #Mitgliedsnummer }.
		{ #Familienname }.
		{ #FamilienNummer }.
		{ #FamilienmitgliedNr }.
		{ #Betrag }.
		{ #Währung }.
		"aus Rechnung"
		{ #AdressatNummer }.
	} ! !

!Rechnungen class methodsFor: 'contexts' stamp: 'hk 8/30/2016 11:11'!
rechnungContext
	self familienConstraint.
	self rechnungBeitragDeclarative.
	
	^GbtPlainAC newStruct: 'RechnungContext' define: {
		{#displayAs: . 'Rechnung'} .
		{#uiSpec:icon: . #GbtDiItemUI . #beitragsMgmt16} .
		{#behavior:arguments:actions: . #positionen . #(v0) . 	"BeitragAbrechnung in v0, Beitrag ist implizit übergeben"
			#(NEWVO	void 													"erzeuge neue Rechnung in context vo"
			ASSIGNSLOT #(Mitgliedsnummer v2)								"kopiere die Mitgliedsnummer"
			WRITESLOT #(v2 AdressatNummer)								"schreibe sie in die Rechnung"	
			TRANSFORM #(thing Rechnungsposition v1)					"das Declarative für die R-Position"	
			ADD2L #(v1 Rechnungspositionen)							"schreibe die erste Pos"
			ASSIGN #(contextVO thing) 									"setzte Rechnung in pipe thing für weitere Verarb. & return"
																		
			ASSIGN #(thing vRg)											"Rechnung in die Variable vRg"		
			MAP #(v0	 Beitragsliste)										"alle Beiträge in list"
			ALTER #(vRg RechnungBeitragDecl )							"forme so um, dass der familienConstraint wirkt"
			FILTER  FamilienConstraint 									"nur die Familienmitglieder = Zusatzpositionen"
			ALTER 	#(void Rechnungsposition)							"neue Positionen "
			REDADD #(thing Rechnungspositionen )						"zu den Positionen"
			)}.													
		}
! !

!Rechnungen class methodsFor: 'contexts' stamp: 'hk 8/28/2016 14:57'!
rechnungenContext
	self rechnungspositionDeclarative.
	self oberhauptConstraint .
	
	^GbtBigListAC newStruct: 'RechnungenContext' define: {
		{#displayAs: . 'Rechnungen'} .
		{#uiSpec:icon: . #GbtListAndItemUI . #bizoffer16} .
		{#templates: . self rechnung} .
		{#loadPolicy: . #autoload } .
		{#display: . #( #(AdressatNummer Mitgliedsnummer) #(Rechnungsbeitrag Beitrag) )} .
		{#subcontext: . self rechnungContext}.
		{#menu: . #Rechnungslauf }.
		{#menu: . #'Neue Rechnung' }.
		{#behavior:actions: . #Rechnungslauf . 
			#(ASKELEM #(BeitragsabrechungenContext v1)			"erfrage die Abrechnung"
			MAP  #(v1 Beitragsliste) 								"hole die Beitragsliste"
			FILTER OberhauptConstraint								"nur die Oberhäupter"
			APPLY #(RechnungContext positionen v1)				"Fülle die Positionen"
		"	FREEZE RechnungDecl 			"							"ins Endformat"
			REFRESH gui )} 	.
		{#behavior:actions: . #'Neue Rechnung' . 
			#(ASKELEM #(BeitragsabrechungenContext	v1)			"welche Abrechnung?"
			ASSIGN #(v1 thing) 										"in v1 UND pipe thing"
			ASKFROM  #(Beitragsliste thing)						"für wen?  -> pipe thing"
			BEHAVIOR #(RechnungContext positionen v1)			"rufe Berechnung auf"				
			REFRESH gui )}. 											" liste wird aktualisiert mit save"
							
		}
! !

!Rechnungen class methodsFor: 'things' stamp: 'hk 8/25/2016 15:30'!
rechnungsadresse
	"self rechnungsadresse edit"
	^GbtThing newStruct: 'Rechnungsadresse' define: { 
		{ #summary . 'system template' }.
		{ #AdressatNummer . #val: . 'bizId'}.
		{ #AdressatName . #val: . '' }.
		{ #AdressatVorname . #val: . '' }.
		{ #StraßeUndNummer . #val: . ''} .
		{ #PLZUndWohnort . #val: . ''}.					
	} ! !

!Rechnungen class methodsFor: 'declaratives' stamp: 'CC 7/22/2016 12:31'!
rechnungsadresseDeclarative
	^GbtDeclarative newStruct: 'Rechnungsadresse' define: { 
		{ #AdressatName . #tag: . #Nachame }.
		{ #AdressatVorname . #tag: . #Vorname }.
		{ #StraßeUndNummer } .
		{ #PLZUndWohnort }.					
	} ! !

!Rechnungen class methodsFor: 'things' stamp: 'hk 8/25/2016 17:22'!
rechnungsposition
	"self rechnungsposition edit"
	^GbtThing newStruct: 'Rechnungsposition' define: { 
		{ #summary . '#Betrag #Währung : #Nachname #Vorname '}.
		{ #Nachname . #val: . ''}.
		{ #Vorname . #val: . ''}.
		{ #Mitgliedsnummer . #val: . '' } .
		{ #AbrechnungVon . #date: . Date current }.		
		{ #AbrechnungBis . #date: . Date current}.
		{ #Betrag . #no: . 0}.
		{ #Währung . #val: . 'EUR'} .
		{ #AbrechnungVon . #date: . Date current}.				
	} 
! !

!Rechnungen class methodsFor: 'declaratives' stamp: 'hk 8/25/2016 18:19'!
rechnungspositionDeclarative
	^GbtDeclarative newStruct: 'Rechnungsposition' define: { 
		{ #summary . '#Nachname , #Vorname : #Betrag #Währung' }.
		{ #Nachname }.
		{ #Vorname }.
		{ #Mitgliedsnummer } .
		{ #AbrechnungVon }.		
		{ #AbrechnungBis }.
		{ #Betrag }.
		{ #Währung } .
		{ #AbrechnungVon . #tag: . #Berechnungsdatum }.				
	} 
! !

Object subclass: #Kommunikation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

Object subclass: #Stammdaten
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

Stammdaten subclass: #Boote
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Boote class methodsFor: 'things' stamp: 'hk 9/30/2016 16:23'!
boot
	"self boot edit"
	^GbtThing newStruct: 'Boot' define: {
		{ #summary . '#Bootsname'  }.
		{ #idNumberPolicy . #BootNoPolicy }.
		{ #Bootstyp . #enum: .  #(Einer Zweier Dreier Vierer Fünfer Achter)}.
		{ #Bootsname . #val: . ''}.
		{ #MannschaftAnzahlMax . #no: . 1}.
	} full: { 
		{ #Steuermann . #enum: .  #(mit ohne)}.
		{ #Baujahr . #val: .  ''}.
	}! !

!Boote class methodsFor: 'testData' stamp: 'CC 8/7/2016 17:47'!
boot01
	^self boot01: self boot! !

!Boote class methodsFor: 'testData' stamp: 'CC 8/7/2016 17:53'!
boot01: aBoot
	"self boot01 edit"

	| b  |
	b := self boot.
	b Bootsname: 'Wisch' .	
	b Bootstyp: #Einer.
	b MannschaftAnzahlMax: 1.	
	b Steuermann: #ohne.
	b Baujahr: 2001.
	^b
! !

!Boote class methodsFor: 'testData' stamp: 'CC 8/7/2016 17:54'!
boot02
	^self boot02: self boot! !

!Boote class methodsFor: 'testData' stamp: 'CC 8/7/2016 17:53'!
boot02: aBoot
	"self boot02 edit"

	| b  |
	b := self boot.
	b Bootsname: 'Alster' .	
	b Bootstyp: #Zweier.
	b MannschaftAnzahlMax: 3.	
	b Steuermann: #mit.
	b Baujahr: 1964.
	^b
! !

!Boote class methodsFor: 'testData' stamp: 'CC 8/7/2016 17:54'!
boot03
	^self boot03: self boot! !

!Boote class methodsFor: 'testData' stamp: 'CC 8/7/2016 17:54'!
boot03: aBoot
	"self boot03 edit"

	| b  |
	b := self boot.
	b Bootsname: 'Elbe' .	
	b Bootstyp: #Zweier.
	b MannschaftAnzahlMax: 2.	
	b Steuermann: #ohne.
	b Baujahr: 1980.
	^b
! !

!Boote class methodsFor: 'contexts' stamp: 'hk 7/12/2016 14:42'!
bootContext
	"comment stating purpose of message"
	
	^GbtPlainAC newStruct: 'BootContext' define: {
		{#displayAs: . 'Boot'  } .
		{#uiSpec:icon: . # GbtItemUI . #rowingBoat}
		}
! !

!Boote class methodsFor: 'contexts' stamp: 'CC 8/7/2016 18:10'!
booteContext
	""
	^GbtBigListAC newStruct: 'BooteContext' define: {
		{#displayAs: . 'Boote'} .
		{#uiSpec:icon: . #GbtListAndItemUI . #rowingBoat} .
		{#templates: . self boot} .
		{#loadPolicy: . #autoload } .
		{#display: . #( #(Bootsname Boot) #(Bootstyp Typ) #(Steuermann Steuermann))} .
		{#subcontext: . self bootContext}
		}

! !

!Boote class methodsFor: 'testData' stamp: 'CC 8/7/2016 18:07'!
booteListe1
	self boot01 save.
	self boot02 save.
	self boot03 save.! !

!Boote class methodsFor: 'example' stamp: 'CC 6/25/2016 20:33'!
exampleRun
	GbtSVO initializeAll.
	self booteContext ui title: #Boote; open! !

Stammdaten subclass: #FahrtenabzeichenStammdaten
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

Stammdaten subclass: #Personen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Personen class methodsFor: 'things' stamp: 'CC 7/8/2016 21:59'!
eMail
	"self eMail edit"
	
	^GbtThing newStruct: 'EMail' define: {
		{ #purposes .   #(Privat Arbeit)}.
		{ #summary .  '#EMail'}.
		{ #EMail . #val: . 'EMail'}.	
 	} full: {  
	}! !

!Personen class methodsFor: 'examples' stamp: 'CC 7/21/2016 19:32'!
exampleRun
	| ui |
	GbtSVO initializeAll.
	(ui := self personenContext ui) title: ('Sportler und Mitglieder', ui title); open! !

!Personen class methodsFor: 'things' stamp: 'CC 8/5/2016 17:06'!
kontaktdaten
	"self kontaktdaten edit"
	
	^GbtThing newStruct: 'Kontaktdaten' define: {
		{ #summary .  'EMail: #EMail Tel: #telNo'}.	
	} full: { 
		{ #StraßeUndNummer . #val: . ''}.
		{ #PLZUndWohnort . #val: .  ''}.
		{ #Kommunikation . #listOf: .  {self telNo . self eMail} }.
	}! !

!Personen class methodsFor: 'things' stamp: 'hk 8/31/2016 13:29'!
kontoDaten
	"self kontoDaten edit"
	
	^GbtThing newStruct: 'KontoDaten' define: {
		{ #summary .  '#Kontoinhaber'}.	
	} full: { 
		{ #Kontoinhaber . #calc: . '#Vorname #Nachname' }.
		{ #IBAN . #val: .  ''}.
		{ #BIC . #val: . ''}.
	}! !

!Personen class methodsFor: 'things' stamp: 'CC 8/30/2016 15:08'!
mitglied
	"self mitglied edit"
	
	^GbtThing newStruct: 'Mitglied' define: {
		{ #summary .  '#bizId : #Mitgliedstatus #Beitragstatus'}.	
		{ #idNumberPolicy . #MitgliedNoPolicy }.
		{ #GebDatum . #date: . Date current }.	
		{ #Mitgliedstatus . #enum: .  #(aktiv passiv) }.	
		{ #Beitragstatus . #enum: . #(Erwachsener 'Nichtverdiener14+' 'Kind14-')}.	
		{ #FamilienOberhaupt . #enum: . #(false true) }.	
		{ #FamilienmitgliedNr . #no: . 1 }.	
		{ #MitgliedSeit . #date: . Date current}.
	} full: { 	
		{ #Beruf . #val: . ''}.	
		{ #Familienname . #val: . ''}.
		{ #FamilienNummer . #val: . 'bizId Oberhaupt'}.			
		{ #Familienmitglieder . #enum: . #() }.	"list of MitgliedBizIds if Familienoberhaupt"
		{ #FahrtenabzeichenStatus . #enum: .  #('M18max' 'W18max' 'M18plus' 'W18plus') }.	
		{ #Schnuppermitglied . #enum: . #(false true) }.	
		{ #Austrittserklärung . #date: . Date current}.
		{ #Austritt . #calc: . '(( #Austrittserklärung  = ''nil'') not ) ifTrue: [ ( #Schnuppermitglied asString = ''true'') ifTrue: [ #MitgliedSeit asDate addMonths: 3 ] ifFalse: [ Date year: (Date current year) month: 12 day: 31 ]]'}.
		"Business rule short in Excel-style:  
		if(#Austrittserklärung = nil; if(#Schnuppermitglied; plusTime (#MitgliedSeit;0;3;0); datum(31;12;jahr(Austrittserklärung)))) "
		{ #KontoDaten . #thing: . self kontoDaten}.		
		{ #Beitragsrechnung . #listOf: . Rechnungen rechnung}.	
		{ #BeitragsSonderregelung . #enum: . #(false true) }.
		{ #Abrechnungsperiode . #enum: . #(jährlich halbjährlich monatlich sonstiges) }.	
"		{ #Ehrungen . #listOf: . { self drvFahrtenabzeichen . self kilometerpreis } }."	
	}

		! !

!Personen class methodsFor: 'things' stamp: 'CC 7/22/2016 10:50'!
person
	"self person edit"
	
	^GbtThing newStruct: 'Person' define: {
		{ #summary .  '#bizId : #Vorname #Nachname'}.	
		{ #idNumberPolicy . #SportlerNoPolicy }.
		{ #Nachname . #val: . ''}.
		{ #Vorname . #val: .  ''}.
		{ #Vorname2 . #val: . ''}.	
		} full: { 
		{ #Kontaktdaten . #thing: . self kontaktdaten }.	
		{ #Sportler . #thing: . self sportlerdaten}.	
		{ #mitglied . #thing: . self mitglied}.		
	}! !

!Personen class methodsFor: 'test data' stamp: 'CC 7/22/2016 10:46'!
person01
	^self person01: self person! !

!Personen class methodsFor: 'test data' stamp: 'hk 8/31/2016 13:33'!
person01: p
	"self person01 editD"

	| m   |
	m := p mitglied.
	m GebDatum: '08.06.1954' .	
	m Mitgliedstatus: #aktiv .	
	m Beitragstatus: #Erwachsener .	
	m FamilienOberhaupt: #true.	
	m FamilienmitgliedNr: 1.	
	m MitgliedSeit: '01.01.1967'.
	m Familienname: #Schmidt .
	m BeitragsSonderregelung: #false .
	m Abrechnungsperiode: #jährlich.	
	m Beruf:'Kaufmann'.
	m Familienname: 'Schmidt'.
	m KontoDaten IBAN: 'DE1234567890'.
	m KontoDaten BIC:'XYZABC'.
	m Abrechnungsperiode: #jährlich.
	
	p Nachname: #Schmidt .
	p Vorname: #Henning.
	p Kontaktdaten StraßeUndNummer: 'Rethfelder Str 48'.
	p Kontaktdaten PLZUndWohnort: '25336 Elmshorn'.
	(p Kommunikation) newEntry: ( self telNo TelNr: '04121 48839'; yourself)  with: 'Privat'.
	p Kommunikation newEntry: (self eMail EMail:'schmidt@gmail.com'; yourself) with: 'Privat'.
	
	^p
! !

!Personen class methodsFor: 'test data' stamp: 'CC 8/5/2016 17:41'!
person02
	^self person02: self person! !

!Personen class methodsFor: 'test data' stamp: 'hk 8/31/2016 13:33'!
person02: p
	"self person02  editD"

	| m   |
	m := p mitglied.
	m GebDatum: '10.07.1961' .	
	m Mitgliedstatus: #aktiv .	
	m Beitragstatus: #Erwachsener .	
	m FamilienOberhaupt: #false.	
	m FamilienmitgliedNr: 2.	
	m MitgliedSeit: '01.15.1993'.
	m Familienname: #Schmidt .
	m BeitragsSonderregelung: #false .
	m Abrechnungsperiode: #jährlich.	
	m Beruf:'Buchhändlerin'.
	m Familienname: 'Schmidt'.
	m FamilienNummer: 'Sportler1'.
	m Abrechnungsperiode: #jährlich.
	
	p Nachname: #Schmidt .
	p Vorname: #Christel.
	p Kontaktdaten StraßeUndNummer: 'Rethfelder Str 48'.
	p Kontaktdaten PLZUndWohnort: '25336 Elmshorn'.
	(p Kommunikation) newEntry: ( self telNo TelNr: '04121 48839'; yourself)  with: 'Privat'.
	p Kommunikation newEntry: (self eMail EMail:'schmidt@gmail.com'; yourself) with: 'Privat'.
	
	^p
! !

!Personen class methodsFor: 'test data' stamp: 'CC 8/5/2016 17:44'!
person03
	^self person03: self person! !

!Personen class methodsFor: 'test data' stamp: 'hk 8/31/2016 13:33'!
person03: p
	"self person03 editD"

	| m   |
	m := p mitglied.
	m GebDatum: '03.10.1996' .	
	m Mitgliedstatus: #aktiv .	
	m Beitragstatus: #Nichtverdiener14plus .	
	m FamilienOberhaupt: #false.	
	m FamilienmitgliedNr: 3.	
	m MitgliedSeit: '01.01.2007'.
	m Familienname: #Schmidt .
	m BeitragsSonderregelung: #false .
	m Abrechnungsperiode: #jährlich.	
	m Beruf:'Schülerin'.
	m Familienname: 'Schmidt'.
	m FamilienNummer: 'Sportler1'.
	m Abrechnungsperiode: #jährlich.
	
	p Nachname: #Schmidt .
	p Vorname: #Imke.
	p Kontaktdaten StraßeUndNummer: 'Rethfelder Str 48'.
	p Kontaktdaten PLZUndWohnort: '25336 Elmshorn'.
	(p Kommunikation) newEntry: ( self telNo TelNr: '04121 48839'; yourself)  with: 'Privat'.
	p Kommunikation newEntry: (self eMail EMail:'schmidt@gmail.com'; yourself) with: 'Privat'.
	
	^p
! !

!Personen class methodsFor: 'test data' stamp: 'CC 8/7/2016 17:36'!
person04
	^self person04: self person! !

!Personen class methodsFor: 'test data' stamp: 'hk 8/31/2016 13:34'!
person04: p
	"self person04 editD"

	| m   |
	m := p mitglied.
	m GebDatum: '10.10.1989' .	
	m Mitgliedstatus: #passiv .	
	m Beitragstatus: #Erwachsener .	
	m FamilienOberhaupt: #false.	
	m FamilienmitgliedNr: 4.	
	m MitgliedSeit: '01.01.2000'.
	m Familienname: #Schmidt .
	m BeitragsSonderregelung: #false .
	m Abrechnungsperiode: #jährlich.	
	m Beruf:'Sozialpädagogin'.
	m Familienname: 'Schmidt'.
	m FamilienNummer: 'Sportler1'.
	m Abrechnungsperiode: #jährlich.
	
	p Nachname: #Schmidt .
	p Vorname: #Levke.
	p Kontaktdaten StraßeUndNummer: 'Rethfelder Str 48'.
	p Kontaktdaten PLZUndWohnort: '25336 Elmshorn'.
	(p Kommunikation) newEntry: ( self telNo TelNr: '04121 48839'; yourself)  with: 'Privat'.
	p Kommunikation newEntry: (self eMail EMail:'schmidt@gmail.com'; yourself) with: 'Privat'.
	
	^p
! !

!Personen class methodsFor: 'contexts' stamp: 'CC 7/22/2016 14:57'!
personContext	
	^GbtPlainAC newStruct: 'PersonContext' define: {
		{#displayAs: . 'Person'  } .
		{#uiSpec:icon: . # GbtDiItemUI . #rower}.
		}! !

!Personen class methodsFor: 'contexts' stamp: 'CC 8/7/2016 17:58'!
personenContext
	""
	
	^GbtBigListAC newStruct: 'PersonenContext' define: {
		{#displayAs: . 'Personen'} .
		{#uiSpec:icon: . #GbtListAndItemUI . #rower} .
		{#templates: . self person} .
"		{#loadPolicy: . #simpleload } ."
		{#loadPolicy: . #autoload } .
		{#display: . #( #(Nachname Name) #(Vorname Vorname))} .
		{#subcontext: . self personContext}
		}
! !

!Personen class methodsFor: 'test data' stamp: 'CC 8/7/2016 17:36'!
personenListe1
	"self personenListe1"
	|  p  |
"	ctxt := GbtBigListAC newStruct: 'PersonenContext' define: {
		{#template: . self person}}."
	1 to: 10 do: [ :n | p := self person01. p Nachname: 'Schmidt',n printString.  "ctxt newEntry: p ." p save ].
	1 to: 1 do: [ :n | p := self person02. p Nachname: 'Schmidt',n printString.  "ctxt newEntry: p ." p save ].
	1 to: 1 do: [ :n | p := self person03. p Nachname: 'Schmidt',n printString.  "ctxt newEntry: p ." p save ].
	1 to: 1 do: [ :n | p := self person04. p Nachname: 'Schmidt',n printString.  "ctxt newEntry: p ." p save ].! !

!Personen class methodsFor: 'things' stamp: 'hk 8/21/2016 19:16'!
sportlerdaten
	"self sportlerdaten  edit"
	
	^GbtThing newStruct: 'Sportlerdaten' define: { 
		{ #summary . 'system template' }.
				} full: { 
		{ #Fremdverein . #val: . ''}.
		{ #Bemerkungen . #text: . ''}.
	}! !

!Personen class methodsFor: 'things' stamp: 'CC 8/5/2016 17:06'!
telNo
	"self telNo edit"
	
	^GbtThing newStruct: 'TelNo' define: {
		{ #purposes .   #(mobileprivat mobilarbeit Privat Arbeit Fax )}.
		{ #summary .  '#TelNr'}.
		{ #TelNr . #val: . 'Telefonnummer'}.	
 	} full: {  
	}! !

Object subclass: #Statistics
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Statistics class methodsFor: 'contexts' stamp: 'hk 9/30/2016 14:56'!
createGlobals
	self ergebnisDecl .
	self transformStatisticDecl.  
	self kmStatisticBoote .
	self kmStatisticRuderer .
! !

!Statistics class methodsFor: 'things' stamp: 'hk 9/30/2016 16:20'!
ergebnis
	"self ergebnis edit"
	^GbtThing newStruct: 'Ergebnis' define: {
		{ #summary . 'km-Statistik' }.
		{ #FahrtID . #val: . '' }.
		{ #Datum . #date: . Date today}.
		{ #Bootsname . #val: . '' }.
		{ #RudererName . #val: . '' }.
		{ #Kilometer . #val: . '' }.
		{ #Abfahrt . #date: . Date today}.
		{ #Ankunft . #date: . Date today}.
		{ #Ziel . #val: . '' }.
	}! !

!Statistics class methodsFor: 'contexts' stamp: 'hk 8/8/2016 17:25'!
ergebnisContext 
	^GbtPlainAC newStruct: 'ErgebnisContext' define: {
		{#displayAs: . 'Ergebnis'  } .
		{#uiSpec:icon: . # GbtItemUI . #statistics}}! !

!Statistics class methodsFor: 'declaratives' stamp: 'hk 9/27/2016 11:22'!
ergebnisDecl
	"Ergebnis-Declarative copies the fields from Fahrt"
	
	^GbtDeclarative newStruct: 'Ergebnis' define: {
		{ #FahrtID . #tag: . #bizId }.
		{ #Bootsname }.
		{ #RudererName }.
		{ #Kilometer }.
		{ #Abfahrt }.
		{ #Ankunft }.
		{ #Ziel }.
	}! !

!Statistics class methodsFor: 'contexts' stamp: 'hk 8/12/2016 18:14'!
ergebnisseContext
	^GbtUlistAC newStruct: 'ErgebnisseContext' define: {
		{#displayAs: . 'Ergebnisse'  } .
		{#uiSpec:icon: . # GbtListAndItemUI . #statistics}.
		{#template:for: . self ergebnis . #resultList } .
		{#display: . #(FahrtID Datum Abfahrt Ankunft Ziel Bootsname RudererName Kilometer)} .
		{#subcontext: . self ergebnisContext}.
		}! !

!Statistics class methodsFor: 'things' stamp: 'hk 9/30/2016 16:13'!
fahrtenConstraint
	"self fahrtenConstraint editD"

	^GbtThing newStruct: 'FahrtenConstraint' define: { 
		{ #begin . #date: .  '1.1.2016' }.
		{ #end . #date: .  '12.31.2016' }.
		{ #gtBegin . #constraint: . '#Abfahrt asDate > #begin asDate'} .
		{ #ltEnd . #constraint: . '#Ankunft asDate < #end asDate'}.
		{ #boot . #val: .  ''}.
		{ #welches . #constraint: . '#Bootsname = #boot'}.
		{ #ruderer . #val: .  ''}.
		{ #fahrtenBesatzung . #ref: . #Besatzung}.
		{ #wer . #constraint: . '(GbtThing typed: #fahrtenBesatzung ) contains: #ruderer at: ''RudererName'''}.
	}.
! !

!Statistics class methodsFor: 'things' stamp: 'hk 9/30/2016 15:39'!
kmStatistic
	"self kmStatistic editD"

	^GbtThing newStruct: 'KmStatistic' define: {
	 	{ #summary . 'km-statistik' }.
		{ #idNumberPolicy . #StatistikNoPolicy }.
		{ #datum . #date: . Date today}.
		{ #km . #sum: .  #Kilometer }.
		{ #startList . #enum: .  #(BooteContext PersonenContext) }.
		{ #resultList . #listOf: . self ergebnis}.
		{ #constraints . #thing: . self fahrtenConstraint}.
	}! !

!Statistics class methodsFor: 'things' stamp: 'hk 9/30/2016 16:09'!
kmStatisticBoote
	"self kmStatisticBoote editD"
	
	| constraint |
	constraint := (self fahrtenConstraint copyWithName: #BooteConstraint)
		define: #begin date:  '1.1.2016' ;
		define: #end  date: '12.31.2016' ;
		removeSmart: #wer;		"darf nicht nach Ruderern fragen"
		yourself.
	
	^(self kmStatistic copyWithName: #KmStatisticBoote)
		summary: 'Boote-Statistik';
		define: #startList val: #BooteContext ;		"startet mit der Booteliste"
		define: #constraints thing: constraint;
		yourself

! !

!Statistics class methodsFor: 'things' stamp: 'hk 9/30/2016 16:09'!
kmStatisticRuderer
	"self kmStatisticRuderer editD"
	
	| constraint |
	constraint := (self fahrtenConstraint copyWithName: #RudererConstraint)
		define: #begin date:  '1.1.2016' ;
		define: #end  date: '12.31.2016' ;
		removeSmart: #welches;	"darf nicht nach Booten fragen"
		yourself.
	
	^(self kmStatistic copyWithName: #KmStatisticRuderer)
		summary: 'Ruderer-Statistik';
		define: #startList val: #PersonenContext ;		"startet mit der Personenliste"
		define: #constraints thing: constraint;
		yourself

! !

!Statistics class methodsFor: 'contexts' stamp: 'hk 9/27/2016 11:26'!
statisticContext
	^GbtPlainAC newStruct: 'StatisticContext' define: {
		{#displayAs: . 'Statistik'  } .
		{#uiSpec:icon: . # GbtItemWithTabsUI . #statistics}.
		{#aspect:on: . self ergebnisseContext . #resultList } .
		{#menu: . #'km-Statistik' }.
		{#behavior:actions: . #'km-Statistik' .  
			#(ASSURETH void 							"schreibe die Statistik íns thing, wenn nicht schon übergeben"
			MAPBL FahrtenBuchContext 				"hole die Fahrten"
			ASSIGNSLOT #(constraints vConstr) 	"constraints aus dem (übergebenen) thing"  
			FILTER vConstr 					
			ALTER #( void Ergebnis ) 				"umformen ins Ergebnis"  
			REDUCE #(thing resultList) ) }. 		"schreibe die Ergebnisliste"
		}! !

!Statistics class methodsFor: 'contexts' stamp: 'hk 9/30/2016 17:19'!
statisticsContext
	self createGlobals .
	
	^GbtBigListAC newStruct: 'StatisticsContext' define: {
		{#displayAs: . 'Statistiken'} .
		{#uiSpec:icon: . #GbtListAndItemUI . #statistics} .
		{#templates: . self kmStatistic } .
		{#loadPolicy: . #simpleload } .
		{#display: . #(summary datum begin end boot ruderer km )} .
		{#subcontext: . self statisticContext}.
		{#menu: . #'Run Statistics' }.
		{#behavior:actions: . #'Run Statistics' . 
			#(ASSIGN #( #(KmStatisticBoote KmStatisticRuderer) stats)
			ASKFROM #(stats thing)							"get the relevant statistics from user -> thing"
			ASSIGNSLOT #(startList vBLc)					"read context name of big list -> vBLc"
			MAPBL vBLc 											"map big list of vBLc"
			ALTER  #(thing TransformStatistic) 			"transform all list elements using TransformStatisticDecl source: pipe thing (the template)"
			APPLY #(StatisticContext 'km-Statistik')	"apply behavior to all list elements"
			ADDBL StatisticsContext) }.						"add the result list"
	}
! !

!Statistics class methodsFor: 'declaratives' stamp: 'hk 9/30/2016 16:11'!
transformStatisticDecl
	"erzeugt die Statistiken aus den Elementen einer Liste von Personen / Booten und der Ausgangsstatistik.
	das leere NewFahrtenConstraint verhindert 'übersprechen' der Daten in den Statistiken"
	
	| constraint |
	
	(self fahrtenConstraint copyWithName: #NewFahrtenConstraint)
		removeSmart: #wer;
		removeSmart: #welches;
		yourself.
	self kmStatistic copyWithName: #TransformStatistic.
	
	constraint := GbtDeclarative newStruct: 'NewFahrtenConstraint' define: {
		{ #begin }.
		{ #end }.
		{ #gtBegin } .
		{ #ltEnd }.
		{ #boot . #tag: . #Bootsname}.
		{ #welches }.
		{ #ruderer . #tag: . #Nachname}.
		{ #fahrtenBesatzung }.
		{ #wer }.
	}.
	^GbtDeclarative newStruct: 'TransformStatistic' define: {
		{ #datum }.
		{ #startList }.
		{ #constraints . #decl: . constraint }
	} ! !
